<template>
  <div class="container-fluid">
    <div class="row">
      <Header />
    </div>
    <div class="row">
      <div class="user-panel">
        <navigation></navigation>
      </div>
      <div class="two-panel">
        <textarea
          class="form-control"
          v-if="type == 'textarea'"
          rows="20"
          v-model="text"
        ></textarea>

        <div class="modal-body" style="width:100%">
          <div class="row">
            <div class="modal-title">
              Your email preview: {{ type }}
              <label
                class="Radio"
                for="responsive_radio"
                style="margin-right: 20px; margin-left: 20px"
              >
                <input
                  class="Radio-Input"
                  v-model="selectStyEmail"
                  type="radio"
                  id="responsive_radio"
                  checked
                  name="radio"
                  value="Responsive Email"
                />
                Responsive Email
              </label>

              <label class="Radio" for="scaled_radio">
                <input
                  class="Radio-Input"
                  v-model="selectStyEmail"
                  type="radio"
                  id="scaled_radio"
                  name="radio"
                  value="Scaled Email"
                />
                Scaled Email
              </label>

              <p class="error" v-if="errorViewHtml">
                Your email size is too large and in Gmail will be clipped.
                Please improve this.
              </p>
            </div>
            <div class="popup_footer">
              <button type="button" class="btn btn-primary" v-on:click="copy">
                Copy as HTML code
              </button>

              <base-button
                @click="backtobuilder"
                class="btn btn-default"
                role="button"
                >Back To Email Builder</base-button
              >
            </div>
            <div class="col-sm-8 ng-star-inserted">
              <center class="mb-10"><b>Desktop</b></center>

              <div class="esdev-desktop-device" style="margin-bottom: 20px">
                <div class="esdev-email-window-panel">
                  <span
                    class="es-icon-user-account esdev-email-user-avatar"
                  ></span>
                  <div class="esdev-email-subject" style="min-height: 20px">
                    &nbsp;
                  </div>
                </div>
                <iframe
                  v-if="strings()"
                  :src="baseURL"
                  class="esdev-desktop-device-screen responsive-iframe"
                ></iframe>
              </div>
            </div>

            <center class="mb-10"><b>Mobile</b></center>

            <div class="col-sm-4 esdev-no-padding-left ng-star-inserted">
              <div class="esdev-mobile-device center-block">
                <div
                  class="esdev-mobile-device-screen"
                  style="margin-bottom: 118px; padding-bottom: 118px"
                >
                  <img alt="" src="@/assets/img/mobile-view-top-bar.png" />
                  <iframe
                    v-if="strings()"
                    :src="baseURL"
                    class="esdev-desktop-device-screen responsive-iframe-mobile"
                  ></iframe>
                  <img
                    alt=""
                    class="esdev-mail-bottom-bar"
                    src="@/assets/img/mobile-view-bottom-bar.png"
                  />
                </div>
              </div>
            </div>
          </div>
          <div class="popup_footer" style="width:100%;float:left">
            <button type="button" class="btn btn-primary" v-on:click="copy">
              Copy as HTML code
            </button>

            <base-button
              @click="backtobuilder"
              class="btn btn-default"
              role="button"
              >Back To Email Builder</base-button
            >
          </div>
        </div>
      </div>
    </div>

    <div class="row">
      <Footer />
    </div>
  </div>
</template>

<script>
import { ModalBus } from "../eventBus";
import { mapGetters } from "vuex";
import Header from "./Header";
import Footer from "./Footer";
import Navigation from "./Navigation";
import { htmlView } from "../utils/viewHtml/responsiveEmail/index";
import { scaleEmail } from "../utils/viewHtml/scaledEmail/index";
export default {
  data() {
    return {
      baseURL:
        window.location.origin + `/iframe?type=${this.$route.query.type}`,
      locations: window.location.origin,
      type: null,
      selectStyEmail: "Responsive Email",
      errorViewHtml: false
    };
  },
  watch: {
    selectStyEmail() {
      this.baseURL =
        window.location.origin + `/iframe?type=${this.selectStyEmail}`;
      this.$router.push(`/htmlview?type=${this.selectStyEmail}`);
      this.$store.dispatch("ACTION_CHANGE_THEME_EMAIL", this.selectStyEmail);
    }
  },
  created() {
    this.selectStyEmail = this.$route.query.type;
  },
  mounted() {
    if (
      this.lengthInUtf8Bytes(htmlView()) > 102 ||
      this.lengthInUtf8Bytes(scaleEmail()) > 102
    ) {
      this.errorViewHtml = true;
    }
  },
  components: {
    Header,
    Footer,
    Navigation
  },
  computed: {
    ...mapGetters(["GETTER_DATA_BANNER", "GETTER_DATA_TOP_PICK"]),
    color() {
      switch (this.type) {
        case "error":
          return "red";
        case "success":
          return "teal";
        case "warning":
          return "orange";
        case "info":
        default:
          return "gray";
      }
    },
    classes() {
      const { color } = this;
      return [
        `bg-${color}-400 border border-${color}-200 text-black px-4 py-3 rounded-lg relative`
      ];
    }
  },
  methods: {
    lengthInUtf8Bytes(str) {
      // Matches only the 10.. bytes that are non-initial characters in a multi-byte sequence.
      var m = encodeURIComponent(str).match(/%[89ABab]/g);
      return parseFloat((str.length + (m ? m.length : 0)) / 1204);
    },
    strings() {
      let data = {
        banner: this.GETTER_DATA_BANNER,
        topPick: this.GETTER_DATA_TOP_PICK
      };

      return JSON.stringify(data);
    },
    backtobuilder() {
      this.$router.push("/");
    },
    copy() {
      var input = document.createElement("textarea");

      if (this.selectStyEmail == "Responsive Email") {
        input.innerHTML = htmlView();
      } else {
        input.innerHTML = scaleEmail();
      }

      document.body.appendChild(input);
      input.select();
      document.execCommand("copy");
      document.body.removeChild(input);

      ModalBus.$emit("showNotify", {
        type: "info",
        text: "Copied HTML code Successfully!"
      });
    }
  }
};
</script>

<style scoped>
iframe.esdev-desktop-device-screen.responsive-iframe {
  width: 100%;
  height: 1000px;
  border: none;
}

iframe.esdev-desktop-device-screen {
  width: 100%;
  height: 100%;
  border: none;
}

.popup_content {
  font-size: 15px;
  padding-bottom: 1em;
}
.popup_footer {
  padding: 1em 0;
  text-align: center;
}
.popup_footer button {
  display: inline-block;
  margin: 0 0.5em;
}
.modal-dialog {
  background: #fff;
  padding: 20px;
  box-shadow: 0 4px 8px 0 rgba(255, 255, 255, 0.2),
    0 6px 20px 0 rgba(255, 255, 255, 0.19);
  /* transition: 0.5s; */
  position: relative;
  max-height: 98%;
}

@import url("../assets/css/response.css");
.responsive-iframe {
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
  width: 100%;
  height: 100%;
  border: none;
}

.responsive-iframe-mobile {
  /* position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
  width: 100%;
  height: 100%;
  border: none; */
}

.modal-title {
  font-weight: 700;
  font-size: 0.8rem;
  margin-bottom: 1rem;
}

.modal-title {
  margin: 0;
  line-height: 1.42857143;
  padding-top: 10px;
  padding-left: 29px;
}
.modal-body {
  padding: 15px 0;
}
</style>

<style>
.modal-dialog {
  width: 90% !important;
}
</style>
